Public Class AddQueueForm

    Private Sub AddQueueForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ListDigitDTMF.Columns.Add("Digits", 120, HorizontalAlignment.Left)
        ListDigitDTMF.Columns.Add("Logins", 180, HorizontalAlignment.Left)

        MainForm.m_objMainForm.SendCommand("ShowQueues", Nothing)
        ClearDlgContent()

    End Sub

    Private Sub BtnAddOP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        If ComboLogin.SelectedIndex = -1 Then
            Exit Sub
        End If

        If ListQueueOP.FindString(ComboLogin.SelectedItem.ToString()) <> -1 Then
            Exit Sub
        End If

        ListQueueOP.Items.Add(ComboLogin.SelectedItem.ToString)
    End Sub

    Private Sub BtnRemoveOP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveOP.Click

        If ListQueueOP.SelectedIndex = -1 Then
            Exit Sub
        End If

        ListQueueOP.Items.Remove(ListQueueOP.SelectedItem)

    End Sub

    Private Sub BtnAddDigitPress_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddDigitPress.Click

        If EditPressDigit.Text.Length = 0 Then
            MessageBox.Show("Enter the digits press by caller. e-g: if caller press 9110 then connect call to user 9110", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        If ComboDigitLogin.SelectedIndex = -1 Then
            MessageBox.Show("Please select the login.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        If Not ListDigitDTMF.FindItemWithText(EditPressDigit.Text) Is Nothing Then
            MessageBox.Show("Digit detect " + EditPressDigit.Text + " already exist.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim nCount As Integer
        Dim sPressDigitUser As String

        For nCount = 0 To ListDigitDTMF.Items.Count - 1
            sPressDigitUser = ListDigitDTMF.Items(nCount).SubItems(1).Text
            If sPressDigitUser = ComboDigitLogin.SelectedItem.ToString() Then
                MessageBox.Show("Login " + sPressDigitUser + " already exist.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
        Next

        Dim ListItem As ListViewItem

        ListItem = ListDigitDTMF.Items.Add(EditPressDigit.Text)
        ListItem.SubItems.Add(ComboDigitLogin.SelectedItem.ToString())

    End Sub

    Private Sub BtnRemoveDigitPress_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveDigitPress.Click

        If ListDigitDTMF.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListDigitDTMF.SelectedItems.Item(0).Remove()

    End Sub

    Private Sub BtnRemoveQueue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveQueue.Click

        If ComboQueue.Text.Length = 0 Then
            MessageBox.Show("Please select queue name.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim objParamList As ArrayList = New ArrayList
        objParamList.Add(ComboQueue.Text)

        MainForm.m_objMainForm.SendCommand("RemoveQueue", objParamList)

    End Sub

    Private Sub BtnAddQueue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddQueue.Click

        If ComboQueue.Text.Length = 0 Then
            MessageBox.Show("Please enter queue name.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        If ComboQueue.FindStringExact(ComboQueue.Text) <> -1 Then

            If MessageBox.Show("Queue already exist, do you want to update it?", "VaxTeleSIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = Windows.Forms.DialogResult.No Then
                Exit Sub
            End If

        End If

        Dim nCount As Integer
        Dim sQueueOPList As String = ""

        For nCount = 0 To ListQueueOP.Items.Count - 1
            sQueueOPList = sQueueOPList + ListQueueOP.Items(nCount) + ","
        Next

        If sQueueOPList.Length > 0 Then
            sQueueOPList = sQueueOPList.Remove(sQueueOPList.Length - 1, 1)
        End If


        '//////////////////////////////////////

        Dim sDigitPressList As String = ""
        Dim sDigitPressUserList As String = ""

        For nCount = 0 To ListDigitDTMF.Items.Count - 1
            sDigitPressList = sDigitPressList + ListDigitDTMF.Items(nCount).Text + ","
            sDigitPressUserList = sDigitPressUserList + ListDigitDTMF.Items(nCount).SubItems(1).Text + ","
        Next

        If sDigitPressList.Length > 0 Then
            sDigitPressList = sDigitPressList.Remove(sDigitPressList.Length - 1, 1)
            sDigitPressUserList = sDigitPressUserList.Remove(sDigitPressUserList.Length - 1, 1)
        End If

        '/////////////////////////////////////

        Dim objParamList As ArrayList = New ArrayList

        objParamList.Add(ComboQueue.Text)
        objParamList.Add(EditQueuePlayWave.Text)
        objParamList.Add(EditDigitDetectPlayWave.Text)
        objParamList.Add(sQueueOPList)
        objParamList.Add(sDigitPressList)
        objParamList.Add(sDigitPressUserList)

        MainForm.m_objTelnetClient.SendCommand("AddQueue", objParamList)

    End Sub

    Private Sub ClearDlgContent()

        ComboQueue.Text = ""

        ListQueueOP.Items.Clear()
        ListDigitDTMF.Items.Clear()

        EditQueuePlayWave.Text = ""
        EditDigitDetectPlayWave.Text = ""

    End Sub

    Private Sub BtnClearQueue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearQueue.Click
        ClearDlgContent()
    End Sub

    Private Sub UpdateDlgContent(ByVal sQueue As String, ByVal sQueuePlayWave As String, ByVal sDigitPressPlayWave As String, ByVal sQueueOPList As String, ByVal sPressDigitList As String, ByVal sPressDigitUserList As String)

        If ComboQueue.Text <> sQueue Then
            Exit Sub
        End If

        EditQueuePlayWave.Text = sQueuePlayWave
        EditDigitDetectPlayWave.Text = sDigitPressPlayWave

        Dim objQueueOPList As ArrayList = New ArrayList
        Dim objPressDigitList As ArrayList = New ArrayList
        Dim objPressDigitUserList As ArrayList = New ArrayList

        MainForm.m_objMainForm.ParseToList(sQueueOPList, objQueueOPList)
        MainForm.m_objMainForm.ParseToList(sPressDigitList, objPressDigitList)
        MainForm.m_objMainForm.ParseToList(sPressDigitUserList, objPressDigitUserList)

        ListQueueOP.Items.Clear()
        ListDigitDTMF.Items.Clear()

        Dim nCount As Integer

        For nCount = 0 To objQueueOPList.Count - 1
            ListQueueOP.Items.Add(objQueueOPList.Item(nCount))
        Next

        Dim ListItem As ListViewItem

        For nCount = 0 To objPressDigitList.Count - 1
            ListItem = ListDigitDTMF.Items.Add(objPressDigitList.Item(nCount))
            ListItem.SubItems.Add(objPressDigitUserList.Item(nCount))
        Next

    End Sub

    Private Sub ComboQueue_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboQueue.SelectedIndexChanged

        Dim objParamList As ArrayList = New ArrayList
        objParamList.Add(ComboQueue.SelectedItem.ToString())

        MainForm.m_objMainForm.SendCommand("QueueInfo", objParamList)

    End Sub

    Public Sub OnTelnetCommand(ByVal sCommand As String, ByRef objParamList As ArrayList)

        If String.Compare(sCommand, "AddUser", True) = 0 And objParamList.Count = 1 Then

            ComboDigitLogin.Items.Add(objParamList.Item(0))
            ComboLogin.Items.Add(objParamList.Item(0))

            Exit Sub
        End If

        If String.Compare(sCommand, "RemoveUser", True) = 0 And objParamList.Count = 1 Then

            Dim nIndex As Integer = ComboLogin.FindStringExact(objParamList.Item(0))

            If nIndex <> -1 Then
                ComboLogin.Items.RemoveAt(nIndex)
            End If

            nIndex = ComboDigitLogin.FindStringExact(objParamList.Item(0))

            If nIndex <> -1 Then
                ComboDigitLogin.Items.RemoveAt(nIndex)
            End If

            Exit Sub
        End If


        If String.Compare(sCommand, "ShowUsers", True) = 0 Then

            Dim nCount As Integer

            For nCount = 0 To objParamList.Count - 1
                ComboLogin.Items.Add(objParamList.Item(nCount))
                ComboDigitLogin.Items.Add(objParamList.Item(nCount))
            Next

            If ComboLogin.Items.Count > 0 Then
                ComboLogin.SelectedIndex = 0
            End If

            If ComboDigitLogin.Items.Count > 0 Then
                ComboDigitLogin.SelectedIndex = 0
            End If

            Exit Sub
        End If

        If String.Compare(sCommand, "ShowQueues", True) = 0 Then

            Dim nCount As Integer

            For nCount = 0 To objParamList.Count - 1
                ComboQueue.Items.Add(objParamList.Item(nCount))
            Next

            If ComboQueue.Items.Count > 0 Then
                ComboQueue.SelectedIndex = 0
            End If

            Exit Sub
        End If


        If String.Compare(sCommand, "QueueInfo", True) = 0 And objParamList.Count = 6 Then

            Dim sQueue As String = objParamList.Item(0)
            Dim sPlayWave As String = objParamList.Item(1)
            Dim sDigitPlayWave As String = objParamList.Item(2)
            Dim sQueueOPList As String = objParamList.Item(3)
            Dim sPressDigitList As String = objParamList.Item(4)
            Dim sPressDigitUserList As String = objParamList.Item(5)

            UpdateDlgContent(sQueue, sPlayWave, sDigitPlayWave, sQueueOPList, sPressDigitList, sPressDigitUserList)

            Exit Sub
        End If


        If String.Compare(sCommand, "RemoveQueue", True) = 0 And objParamList.Count = 1 Then

            Dim nIndex As Integer = ComboQueue.FindStringExact(objParamList.Item(0))
            If nIndex = -1 Then
                Exit Sub
            End If

            ComboQueue.Items.RemoveAt(nIndex)

            MessageBox.Show("Queue removed successfully!", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            ClearDlgContent()

            Exit Sub
        End If


        If String.Compare(sCommand, "AddQueue", True) = 0 And objParamList.Count = 1 Then

            ComboQueue.Items.Add(objParamList.Item(0))
            MessageBox.Show("Queue created successfully", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

            Exit Sub
        End If

        If String.Compare(sCommand, "UpdateQueue", True) = 0 And objParamList.Count = 1 Then

            MessageBox.Show("Queue updated successfully", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If


    End Sub
End Class