#include "StdAfx.h"
#include "AddQueueForm.h"

#include "MainForm.h"

using namespace VaxTeleConfigSIP;


void AddQueueForm::AddQueueForm_Load(System::Object^  sender, System::EventArgs^  e) 
{
	ListDigitDTMF->Columns->Add("Digits", 120, HorizontalAlignment::Left);
	ListDigitDTMF->Columns->Add("Logins", 180, HorizontalAlignment::Left);

	MainForm::m_objMainForm->SendCommand("ShowQueues");
	ClearDlgContent();
}


void AddQueueForm::BtnAddOP_Click(System::Object^  sender, System::EventArgs^  e)
{
	if(ComboLogin->SelectedIndex == -1)
		return;

	if (ListQueueOP->FindString(ComboLogin->SelectedItem->ToString()) != -1)
		return;

	ListQueueOP->Items->Add(ComboLogin->SelectedItem->ToString());
}

void AddQueueForm::BtnRemoveOP_Click(System::Object^  sender, System::EventArgs^  e)
{
	if (ListQueueOP->SelectedIndex == -1)
		return;

	ListQueueOP->Items->Remove(ListQueueOP->SelectedItem);
}

void AddQueueForm::BtnAddDigitPress_Click(System::Object^  sender, System::EventArgs^  e)
{
	if (EditPressDigit->Text->Length == 0)
	{
		MessageBox::Show("Enter the digits press by caller. e-g: if(caller press 9110) connect call to user 9110", "VaxTeleSIP", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
		return;
	}

	if (ComboDigitLogin->SelectedIndex == -1)
	{
		MessageBox::Show("Please select the login.", "VaxTeleSIP", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
		return;
	}

	if (ListDigitDTMF->FindItemWithText(EditPressDigit->Text) != nullptr)
	{
		MessageBox::Show("Digit detect " + EditPressDigit->Text + " already exist.", "VaxTeleSIP", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
		return;
	}

	for (int nCount = 0; nCount < ListDigitDTMF->Items->Count; nCount++)
	{
		String^ sPressDigitUser = ListDigitDTMF->Items[nCount]->SubItems[1]->Text;

		if (sPressDigitUser == ComboDigitLogin->SelectedItem->ToString())
		{
			MessageBox::Show("Login " + sPressDigitUser + " already exist.", "VaxTeleSIP", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			return;
		}
	}

	ListViewItem^ ListItem = ListDigitDTMF->Items->Add(EditPressDigit->Text);
	ListItem->SubItems->Add(ComboDigitLogin->SelectedItem->ToString());
}

void AddQueueForm::BtnRemoveDigitPress_Click(System::Object^  sender, System::EventArgs^  e)
{
	if(ListDigitDTMF->SelectedItems->Count == 0)
		return;
	
	ListDigitDTMF->SelectedItems[0]->Remove();
}

void AddQueueForm::BtnRemoveQueue_Click(System::Object^  sender, System::EventArgs^  e)
{
	if(ComboQueue->Text->Length == 0)
	{
		MessageBox::Show("Please select queue name.", "VaxTeleSIP", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
		return;
	}

	ArrayList^ objParamList = gcnew ArrayList();
	objParamList->Add(ComboQueue->Text);

	MainForm::m_objMainForm->SendCommand("RemoveQueue", objParamList);
}

void AddQueueForm::BtnAddQueue_Click(System::Object^  sender, System::EventArgs^  e)
{
	if(ComboQueue->Text->Length == 0)
	{
		MessageBox::Show("Please enter queue name.", "VaxTeleSIP", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
		return;
	}

	if(ComboQueue->FindStringExact(ComboQueue->Text) != -1)
	{
		if(MessageBox::Show("Queue already exist, do you want to update it?", "VaxTeleSIP", MessageBoxButtons::YesNo, MessageBoxIcon::Exclamation) == ::DialogResult::No)
			return;
	}

	String^ sQueueOPList = gcnew String("");

	for(int nCount = 0; nCount < ListQueueOP->Items->Count; nCount++)
		sQueueOPList = sQueueOPList + ListQueueOP->Items[nCount] + ",";

	if(sQueueOPList->Length > 0)
		sQueueOPList = sQueueOPList->Remove(sQueueOPList->Length - 1, 1);

	//////////////////////////////////////

	String^ sDigitPressList = gcnew String("");
	String^ sDigitPressUserList = gcnew String("");

	for(int nCount = 0; nCount < ListDigitDTMF->Items->Count; nCount++)
	{
		sDigitPressList = sDigitPressList + ListDigitDTMF->Items[nCount]->Text + ",";
		sDigitPressUserList = sDigitPressUserList + ListDigitDTMF->Items[nCount]->SubItems[1]->Text + ",";
	}

	if(sDigitPressList->Length > 0)
	{
		sDigitPressList = sDigitPressList->Remove(sDigitPressList->Length - 1, 1);
		sDigitPressUserList = sDigitPressUserList->Remove(sDigitPressUserList->Length - 1, 1);
	}

	/////////////////////////////////////

	ArrayList^ objParamList = gcnew ArrayList();

	objParamList->Add(ComboQueue->Text);
	objParamList->Add(EditQueuePlayWave->Text);
	objParamList->Add(EditDigitDetectPlayWave->Text);
	objParamList->Add(sQueueOPList);
	objParamList->Add(sDigitPressList);
	objParamList->Add(sDigitPressUserList);

	MainForm::m_objMainForm->SendCommand("AddQueue", objParamList);
}

void AddQueueForm::ClearDlgContent()
{
	ComboQueue->Text = "";

	ListQueueOP->Items->Clear();
	ListDigitDTMF->Items->Clear();

    EditQueuePlayWave->Text = "";
    EditDigitDetectPlayWave->Text = "";
}

void AddQueueForm::BtnClearQueue_Click(System::Object^  sender, System::EventArgs^  e)
{
	ClearDlgContent();
}

void AddQueueForm::UpdateDlgContent(String^ sQueue, String^ sQueuePlayWave, String^ sDigitPressPlayWave, String^ sQueueOPList, String^ sPressDigitList, String^ sPressDigitUserList)
{
	if(ComboQueue->Text != sQueue)
		return;

	EditQueuePlayWave->Text = sQueuePlayWave;
	EditDigitDetectPlayWave->Text = sDigitPressPlayWave;

    ArrayList^ objQueueOPList = gcnew ArrayList();
    ArrayList^ objPressDigitList = gcnew ArrayList();
    ArrayList^ objPressDigitUserList = gcnew ArrayList();

	MainForm::m_objMainForm->ParseToList(sQueueOPList, objQueueOPList);
	MainForm::m_objMainForm->ParseToList(sPressDigitList, objPressDigitList);
	MainForm::m_objMainForm->ParseToList(sPressDigitUserList, objPressDigitUserList);

	ListQueueOP->Items->Clear();
	ListDigitDTMF->Items->Clear();

	for (int nCount = 0; nCount < objQueueOPList->Count; nCount++)
		ListQueueOP->Items->Add(objQueueOPList[nCount]);

	ListViewItem^ ListItem;

	for (int nCount = 0; nCount < objPressDigitList->Count; nCount++)
	{
		ListItem = ListDigitDTMF->Items->Add((String^) objPressDigitList[nCount]);
		ListItem->SubItems->Add((String^) objPressDigitUserList[nCount]);
	}
}

void AddQueueForm::ComboQueue_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
{
	ArrayList^ objParamList = gcnew ArrayList();
	objParamList->Add(ComboQueue->SelectedItem->ToString());

	MainForm::m_objMainForm->SendCommand("QueueInfo", objParamList);
}

void AddQueueForm::OnTelnetCommand(String^ sCommand, ArrayList^ objParamList)
{
    if (String::Compare(sCommand, "AddUser", true) == 0 && objParamList->Count == 1)
    {
        ComboDigitLogin->Items->Add(objParamList[0]);
        ComboLogin->Items->Add(objParamList[0]);

        return;
    }

    if (String::Compare(sCommand, "RemoveUser", true) == 0 && objParamList->Count == 1)
    {
        int nIndex = ComboLogin->FindStringExact((String^) objParamList[0]);

        if (nIndex != -1)
            ComboLogin->Items->RemoveAt(nIndex);

        nIndex = ComboDigitLogin->FindStringExact((String^) objParamList[0]);

        if (nIndex != -1)
            ComboDigitLogin->Items->RemoveAt(nIndex);

        return;
    }


    if (String::Compare(sCommand, "ShowUsers", true) == 0)
    {

        for (int nCount = 0; nCount < objParamList->Count; nCount++)
        {
            ComboLogin->Items->Add(objParamList[nCount]);
            ComboDigitLogin->Items->Add(objParamList[nCount]);
        }

        if (ComboLogin->Items->Count > 0)
            ComboLogin->SelectedIndex = 0;

        if (ComboDigitLogin->Items->Count > 0)
            ComboDigitLogin->SelectedIndex = 0;

        return;
    }

    if (String::Compare(sCommand, "ShowQueues", true) == 0)
    {
        for (int nCount = 0; nCount < objParamList->Count; nCount++)
            ComboQueue->Items->Add(objParamList[nCount]);

        if (ComboQueue->Items->Count > 0)
            ComboQueue->SelectedIndex = 0;

        return;
    }

    if (String::Compare(sCommand, "QueueInfo", true) == 0 && objParamList->Count == 6)
    {
        String^ sQueue = (String^) objParamList[0];
        String^ sPlayWave = (String^) objParamList[1];
        String^ sDigitPlayWave = (String^) objParamList[2];
        String^ sQueueOPList = (String^) objParamList[3];
        String^ sPressDigitList = (String^) objParamList[4];
        String^ sPressDigitUserList = (String^) objParamList[5];

        UpdateDlgContent(sQueue, sPlayWave, sDigitPlayWave, sQueueOPList, sPressDigitList, sPressDigitUserList);

        return;
    }

    if (String::Compare(sCommand, "RemoveQueue", true) == 0 && objParamList->Count == 1)
    {
        int nIndex = ComboQueue->FindStringExact((String^) objParamList[0]);
        if (nIndex == -1) return;

        ComboQueue->Items->RemoveAt(nIndex);

        MessageBox::Show("Queue removed successfully!", "VaxTeleSIP", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
        ClearDlgContent();

        return;
    }

    if (String::Compare(sCommand, "AddQueue", true) == 0 && objParamList->Count == 1)
    {
        ComboQueue->Items->Add(objParamList[0]);
        MessageBox::Show("Queue created successfully", "VaxTeleSIP", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);

        return;
    }

    if (String::Compare(sCommand, "UpdateQueue", true) == 0 && objParamList->Count == 1)
    {
        MessageBox::Show("Queue updated successfully", "VaxTeleSIP", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
        return;
    }
}
