#include "StdAfx.h"
#include "ServerSIP.h"
#include "UserList.h"

cUserData::cUserData()
{
	m_nCallCount = 0;
	m_unUserId = 0;
	m_bStealthListener = false;
	m_bBlock = false;

	m_sCodecList = gcnew String("");
	m_sUserId = gcnew String("");
}

cUserList::cUserList(void)
{
	m_unUserIdCount = 0;
	
	m_objUserListTEXT = gcnew Hashtable(256);
    m_objUserListINT = gcnew Hashtable(256);
}

unsigned int cUserList::ChooseUserId()
{
    while (true)
    {
        m_unUserIdCount++;

        if(FindUser(m_unUserIdCount) == nullptr)
            break;
    }

    return m_unUserIdCount;
}

bool cUserList::AddUser(String^ sUserId, String^ sUserPwd, Boolean bStealthListener, String^ sCodecList, Boolean bBlock)
{
    if(cServerSIP::m_objServerSIP->AddUser(sUserId, sUserPwd) == false)
    {
        cServerSIP::m_objServerSIP->LogError("");
        return false;
    }

    Remove(sUserId);

    Add(sUserId, bStealthListener, sCodecList, bBlock);

    return true;
}

void cUserList::RemoveUser(String^ sUserId)
{
    cServerSIP::m_objServerSIP->RemoveUser(sUserId);
    
    Remove(sUserId);
}
    
cUserData^ cUserList::FindUser(unsigned int unUserId)
{
    return (cUserData^) m_objUserListINT[unUserId];
}

cUserData^ cUserList::FindUser(String^ sUserId)
{
    return (cUserData^) m_objUserListTEXT[sUserId->ToLower()];
}

void cUserList::DeleteAll()
{
    m_objUserListTEXT->Clear();
    m_objUserListINT->Clear();
}

int cUserList::GetCallCount(String^ sUserId)
{
    cUserData^ objUserData = FindUser(sUserId);

    if (objUserData == nullptr)
        return -1;

    return objUserData->m_nCallCount;
}

void cUserList::Add(String^ sUserId, Boolean bStealthListener, String^ sCodecList, Boolean bBlock)
{
    cUserData^ objUserData = gcnew cUserData();

    objUserData->m_sUserId = sUserId;
    objUserData->m_unUserId = ChooseUserId();
    objUserData->m_bStealthListener = bStealthListener;
    objUserData->m_sCodecList = sCodecList;
    objUserData->m_bBlock = bBlock;

    m_objUserListINT->Add(objUserData->m_unUserId, objUserData);
    m_objUserListTEXT->Add(sUserId->ToLower(), objUserData);
}

void cUserList::Remove(String^ sUserId)
{
    sUserId = sUserId->ToLower();
    cUserData^ objUserData = (cUserData^) m_objUserListTEXT[sUserId];

    if (objUserData == nullptr) return;

    m_objUserListINT->Remove(objUserData->m_unUserId);
    m_objUserListTEXT->Remove(sUserId);

    objUserData = nullptr;
}

int cUserList::GetCount()
{
    return m_objUserListINT->Count;
}
