#pragma once

using namespace System;
using namespace System::Collections::Generic;
using namespace System::Text;
using namespace VAXTELESERVERSIPLib;

public ref class cVaxTeleCOM
{

public:
	
	cVaxTeleCOM(void);

public:

	VaxTeleSIP^ m_objVaxTeleCOM;

public:

	void SetLicenseKey(String^ sLicenseKey);
	void UnInitialize();
	bool Initialize(String^ sDomainRealm, String^ sSIPListenIP, int nSIPListenPort, String^ sRTPListenIP, int nRTPListenPort);
	bool AcceptCall(int nCallId, String^ sCodecList, int nTimeOut);
	bool CloseCall(int nCallId);
	int CreateSession();
	bool AddCallToSession(int nCallId, int nSessionId);
	bool RemoveCallToSession(int nCallId);
	void CloseSession(int nSessionId);
	int GetVaxObjectError();
	int DialCallToUser(String^ sCallFrom, String^ sToUserLogin, String^ sCodecList, int nTimeOut);
	int DialCallToLine(int nLineId, String^ sDialNo, String^ sCodecList, int nTimeOut);
	int DialCallToURI(String^ sFromURI, String^ sToURI, String^ sProxyURI, String^ sLogin, String^ sLoginPwd, String^ sCodecList, int nTimeOut);
	bool SendResponse(int nCallId, int nStatusCode, String^ sReasonPhrase, String^ sCodecList);
	bool RegisterLine(int nLineId);
	bool UnRegisterLine(int nLineId);
	bool AddLine(int nLineId, String^ sUserName, String^ sLogin, String^ sLoginPwd, String^ sDisplayName, String^ sDomainRealm, String^ sProxyURI, String^ sOutboundProxy);
	void RemoveLine(int nLineId);
	bool AddUser(String^ sUserLogin, String^ sLoginPwd);
	void RemoveUser(String^ sUserLogin);
	bool AuthClientRegister(int nRegId);
	bool AcceptClientRegister(int nRegId);
	bool RejectClientRegister(int nRegId);
	int PlayWaveLoadFile(String^ sFileName);
	void PlayWaveUnLoadFile(int nPlayWaveId);
	bool PlayWaveStartToSession(int nPlayWaveId, int nSessionId, bool bLoopPlay);
	bool PlayWaveStopToSession(int nSessionId);
	bool PlayWaveResetToSession(int nSessionId);
	bool RecordWaveStartToSession(String^ sFileName, int nSessionId);
	bool RecordWaveStopToSession(int nSessionId);
	bool RecordWavePauseToSession(bool bEnable, int nSessionId);
	bool TransferCallAccept(int nCallId);
	bool TransferCallReject(int nCallId);
	bool SendDTMF(int nTypeDTMF, int nCallId, int nDigit);
	bool DetectDTMF(int nTypeDTMF, int nSessionId, bool bEnable);
	bool SessionLost(bool bEnable);
	int GetCallSession(int nCallId);
	bool EnableDialTone(int nCallId, int nSessionId);
	bool DisableDialTone(int nCallId);
	bool SetVaxTeleTick(int nTickId, int nElapse);
	bool KillVaxTeleTick(int nTickId);

public:

	static void OnClientUnRegister(String^ sUserLogin);
	static void OnClientRegister(String^ sUserLogin, String^ sDomain, int nRegId);

	static void OnClientRegisterSuccess(String^ sUserLogin);
	static void OnClientRegisterFail(String^ sUserLogin);

	static void OnLineRegisterTrying(int nLineId);
	static void OnLineRegisterFail(int nLineId, int nStatusCode, String^ sReasonPhrase);
	static void OnLineRegisterSuccess(int nLineId);

	static void OnIncomingCallFromLine(int nCallId, int nLineId, String^ sCallFrom, String^ sCallTo, String^ sFromURI, String^ sToURI, String^ sFromIP, int nFromPort);
	static void OnIncomingCallFromUser(int nCallId, String^ sUserName, String^ sCallFrom, String^ sCallTo, String^ sFromURI, String^ sToURI, String^ sFromIP, int nFromPort);
	static void OnIncomingCallAnonymous(int nCallId, String^ sCallFrom, String^ sCallTo, String^ sFromURI, String^ sToURI, String^ sFromIP, int nFromPort);
	static void OnIncomingCallCancel(int nCallId);
	
	static void OnDialCallConnected(int nCallId); 
	static void OnAcceptIncomingCallConnected(int nCallId);

	static void OnDisconnectCall(int nCallId);
	static void OnSessionLost(int nCallId);
	
	static void OnDialCallTimeOut(int nCallId);
	static void OnAcceptCallTimeOut(int nCallId);

	static void OnProvisionalResponse(int nCallId, int nStatusCode, String^ sReasonPhrase);
	static void OnFailureResponse(int nCallId, int nStatusCode, String^ sReasonPhrase);
	static void OnRedirectionResponse(int nCallId, int nStatusCode, String^ sReasonPhrase, String^ sContact);

	static void OnPlayWaveToSessionDone(int nPlayWaveId, int nSessionId);
	static void OnDigitDetectDTMF(int nSessionId, int nCallId, int nDigit);

	static void OnTransferCallBlind(int nCallId, String^ sTransferee, String^ sTransferTo, String^ sTransferToURI);
	static void OnTransferCallAttend(int nCallId, int nTransferToCallId);
	static void OnHoldCall(int nCallId);
	static void OffHoldCall(int nCallId);
	static void OnVaxTeleTick(int nTickId);
	static void OnLineUnRegisterTrying(int nLineId);
	static void OnLineUnRegisterFail(int nLineId, int nStatusCode, String^ sReasonPhrase);
	static void OnLineUnRegisterSuccess(int nLineId);

};
