// Registry.h: interface for the CRegistry class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REGISTRY_H__9DE75C25_DA0E_4551_96CA_19FC887269EC__INCLUDED_)
#define AFX_REGISTRY_H__9DE75C25_DA0E_4551_96CA_19FC887269EC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CQueueReg
{
	
public:

	CString m_sPlayWave;
	CString m_sPressDigitPlayWave;

	CStringList m_objQueueOPList;
	CStringList m_objPressDigitList;
	CStringList m_objPressDigitUserList;
};

class CLoginReg
{

public:

	CString m_sCodec;
	CString m_sPassword;

	BOOL m_bBlock;
	BOOL m_bStealth;
};


class CLineReg
{
	
public:

	CString m_sDisplayName;
    CString m_sUserName;
    CString m_sAuthUser;
    CString m_sPassword;
    CString m_sRealm;
    CString m_sProxy;
    CString m_sOutboundProxy;
    
	BOOL m_bRegister;
    CString m_sInCallType;
    CString m_sInCallTo;
    
	CString m_sCodec;
};

class CDialPlanReg
{
	
public:

	CString m_sLineName;
    CString m_sCallPrefix;
};


class CRegistry  
{
public:
	CRegistry();
	~CRegistry();

public:

	HKEY m_hKey;

public:

	CString GetStealthListenerMusic();
	BOOL SetStealthListenerMusic(LPCTSTR sPlayWave);
	
	BOOL SetHoldMusic(LPCTSTR sPlayWave);
	CString GetHoldMusic();

	BOOL SetDialToneMusic(LPCTSTR sPlayWave);
	CString GetDialToneMusic();
	
	BOOL SetCOMM(LPCTSTR sListenIP, LPCTSTR sListenPort, LPCTSTR sDominRealm);
	BOOL GetCOMM(CString& sListenIP, CString& sListenPort, CString& sDominRealm);
	
	/*
	DWORD GetErrorCount();
	void SetErrorCount(DWORD dwErrorCount);
	void SetError(int nErrorCode, LPCTSTR sErrorMsg);
	CString GetError(int nCount);
	void RemoveErrorAll();
	*/
	
	/*
	BOOL IsPlayMsgExist(LPCTSTR sPlayMsg);
	BOOL SetPlayMsg(LPCTSTR sPlayMsg, LPCTSTR sPlayWave);
	BOOL GetPlayMsg(LPCTSTR sPlayMsg, CString& sPlayWave);
	CString EnumPlayMsg(int nIndex);
	BOOL RemovePlayMsg(LPCTSTR sPlayMsg);
	*/
	
	BOOL IsQueueExist(LPCTSTR sQueue);
	BOOL SetQueue(LPCTSTR sQueue, CQueueReg* pQueueReg);
	BOOL GetQueue(LPCTSTR sQueue, CQueueReg* pQueueReg);
	void EnumQueue(CStringList* pQueueList);
	BOOL RemoveQueue(LPCTSTR sQueue);

	BOOL IsLoginExist(LPCTSTR sLogin);
	BOOL IsLoginStealth(LPCTSTR sLogin);
	void EnumLogin(CStringList* pLoginList);
	BOOL RemoveLogin(LPCTSTR sLogin);
	BOOL GetLogin(LPCTSTR sLogin, CLoginReg* pLoginReg);
	BOOL SetLogin(LPCTSTR sLogin, CLoginReg* pLoginReg);
	
	void EnumLine(CStringList* pLineList);
	BOOL IsLineExist(LPCTSTR sLine);
	
	BOOL GetLine(LPCTSTR sLineName, CLineReg* pLineReg);
	BOOL SetLine(LPCTSTR sLineName, CLineReg* pLineReg);
	
	BOOL RemoveLine(LPCTSTR sLine);

	BOOL GetDialPlan(LPCTSTR sUserPrefix, CDialPlanReg* pDialPlanReg);
	BOOL SetDialPlan(LPCTSTR sUserPrefix, CDialPlanReg* pDialPlanReg);

	void EnumDialPlan(CStringList* pDialPlanList);
	BOOL RemoveDialPlan(LPCTSTR sUserPrefix);

	BOOL SetStartServer(BOOL bEnable);
	BOOL GetStartServer();
	
};

#endif // !defined(AFX_REGISTRY_H__9DE75C25_DA0E_4551_96CA_19FC887269EC__INCLUDED_)
