// ResponseEvent.cpp: implementation of the CResponseEvent class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ServerSIP.h"
#include "ResponseEvent.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CResponseEvent::CResponseEvent()
{

}

CResponseEvent::~CResponseEvent()
{

}

void CResponseEvent::OnProvisionalResponse(CCallData* pCallData, long lStatusCode, LPCTSTR sReasonPhrase) 
{
	if(pCallData->m_pBindCallData == NULL || pCallData->m_pBindCallData->m_bConnected == TRUE) 
		return;

	CServerSIP::m_pServerSIP->SendResponse(pCallData->m_pBindCallData, lStatusCode, sReasonPhrase);
	
}

void CResponseEvent::OnFailureResponse(CCallData* pCallData, long lStatusCode, LPCTSTR sReasonPhrase) 
{
	CCallData* pBindCallData = pCallData->m_pBindCallData;
	
	if(pBindCallData != NULL)
		CServerSIP::m_pServerSIP->CloseCall(pBindCallData);
	
	CServerSIP::m_pServerSIP->CloseCall(pCallData);
}

void CResponseEvent::OnRedirectionResponse(CCallData* pCallData, long lStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sContact) 
{
	OnFailureResponse(pCallData, lStatusCode, sReasonPhrase);
}