using System;
using System.Collections;
using System.Text;


class cDialPlanData
{
    public int m_nUserPrefixSize;
    public string m_sUserPrefix;
    public string m_sLineName;
    public string m_sCallPrefix;

    public cDialPlanData()
    {
        m_nUserPrefixSize = 0;
        m_sUserPrefix = "";
        m_sLineName = "";
        m_sCallPrefix = "";
    }
}

class cDialPlanList
{
    public ArrayList m_objDialPlanList = new ArrayList();

    public void ReLoadDialPlans()
    {
        UnLoadDialPlans();
        LoadDialPlans();
    }

    public void UnLoadDialPlans()
    {
        m_objDialPlanList.Clear();
    }

    public void LoadDialPlans()
    {
        m_objDialPlanList.Clear();

        ArrayList objDialPlanList = new ArrayList();
        
        cRegistry objReg = new cRegistry();
        if (objReg.EnumDialPlan(ref objDialPlanList) == false)
            return;
        
        cDialPlanReg objDialPlanReg = new cDialPlanReg();

        for (int nCount = 0; nCount < objDialPlanList.Count; nCount++)
        {
            if (objReg.GetDialPlan((string) objDialPlanList[nCount], ref objDialPlanReg) == false)
                continue;

            cDialPlanData objDialPlanData = new cDialPlanData();

            objDialPlanData.m_sLineName = objDialPlanReg.m_sLineName;
            objDialPlanData.m_sCallPrefix = objDialPlanReg.m_sCallPrefix;

            objDialPlanData.m_sUserPrefix = (string) objDialPlanList[nCount];
            objDialPlanData.m_nUserPrefixSize = ((string) objDialPlanList[nCount]).Length;

            m_objDialPlanList.Add(objDialPlanData);
        }
    }

    public int SearchDialPlan(string sCallTo)
    {
        int nCallToLen = sCallTo.Length;

        for (int nCount = 0; nCount < m_objDialPlanList.Count; nCount++)
        {
            cDialPlanData objDialPlanData = (cDialPlanData) m_objDialPlanList[nCount];
            int nPrefixLen = objDialPlanData.m_nUserPrefixSize;

            if (nCallToLen <= objDialPlanData.m_nUserPrefixSize)
                continue;

            if (sCallTo.Substring(0, objDialPlanData.m_nUserPrefixSize) == objDialPlanData.m_sUserPrefix)
                return nCount;
        }

        return -1;
    }

    public string ApplyDialPlan(int nDialPlanIndex, string sCallTo, ref string sLineName)
    {
        cDialPlanData objDialPlanData = (cDialPlanData)m_objDialPlanList[nDialPlanIndex];
        sCallTo = sCallTo.Remove(0, objDialPlanData.m_nUserPrefixSize);

        sLineName = objDialPlanData.m_sLineName;
               
        if (objDialPlanData.m_sCallPrefix.Length == 0)
            return sCallTo;

        return (objDialPlanData.m_sCallPrefix + sCallTo);
    }

}

